﻿/**
 * Copyright 2008 - TMTDigital LLC
 *
 * Author:   Travis Tidwell (www.travistidwell.com)
 * Version:  1.0
 * Date:     June 9th, 2008
 *
 * Description:  A movie clip with a list of filter buttons within.
 *
 **/

package com.tmtdigital.dash.display
{
   import com.tmtdigital.dash.display.Skinable;
   import com.tmtdigital.dash.display.Link;
   import com.tmtdigital.dash.events.DashEvent;
   import flash.display.*;

   public class FilterList extends Skinable
   {
      public function FilterList( _skin:MovieClip, _callExternal:Boolean = false )
      {
         callExternal = _callExternal;
         super( _skin );
      }

      public override function setSkin( _skin:MovieClip )
      {
         super.setSkin( _skin );
         loadFilters();
      }

      public function loadFilters()
      {
         if( skin ) {
            filters = new Array();
            var i:Number = skin.numChildren;
            while( i-- ) {
               var filterSkin:MovieClip = (skin.getChildAt(i) as MovieClip);
               var filter:Link = new Link( filterSkin, callExternal );
               filter.addEventListener( DashEvent.LINK_CLICK, onClicked );
               filter.setLink( "", filterSkin.name, 0 );
               links.push( filter );
            }
         }
      }

      private function onClicked( event:DashEvent )
      {
			if( currentFilter ) {
				currentFilter.setSelected( false );
			}
			
			currentFilter = (event.target as Link);
      }
      
      private var links:Array;
      private var currentFilter:Link;
      private var callExternal:Boolean;
   }
}